package hieda_yamlutil

type CommonLogConfigYAML_BKE_AliSLS_ExtendCfg struct {
	TotalSizeLnBytes      int64  `yaml:"total_size_ln_bytes"`
	MaxIoWorkerCount      int64  `yaml:"max_io_worker_count"`
	MaxBlockSec           int    `yaml:"max_block_sec"`
	MaxBatchSize          int64  `yaml:"max_batch_size"`
	MaxBatchCount         int    `yaml:"max_batch_count"`
	LingerMs              int64  `yaml:"linger_ms"`
	Retries               int    `yaml:"retries"`
	MaxReservedAttempts   int    `yaml:"max_reserved_attempts"`
	BaseRetryBackoffMs    int64  `yaml:"base_retry_backoff_ms"`
	MaxRetryBackoffMs     int64  `yaml:"max_retry_backoff_ms"`
	AdjustShargHash       bool   `yaml:"adjust_sharg_hash"`
	Buckets               int    `yaml:"buckets"`
	AllowLogLevel         string `yaml:"allow_log_level"`
	LogFileName           string `yaml:"log_file_name"`
	IsJsonType            bool   `yaml:"is_json_type"`
	LogMaxSize            int    `yaml:"log_max_size"`
	LogMaxBackups         int    `yaml:"log_max_backups"`
	LogCompress           bool   `yaml:"log_compress"`
	NoRetryStatusCodeList []int  `yaml:"no_retry_status_code_list"`
}

type CommonLogConfigYAML_BKE_AliSLS struct {
	EnableAliSLSProducerDebug bool                                      `yaml:"alisls_producer_debug"`
	Hostname                  string                                    `yaml:"hostname"`
	AppName                   string                                    `yaml:"appname"`
	Appkey                    string                                    `yaml:"ak_id"`
	Secret                    string                                    `yaml:"ak_secret"`
	Endpoint                  string                                    `yaml:"endpoint"`
	Project                   string                                    `yaml:"project"`
	Logstore                  string                                    `yaml:"logstore"`
	Topic                     string                                    `yaml:"topic"`
	EmitIP                    string                                    `yaml:"emit_ip"`
	OverrideWithRealIP        bool                                      `yaml:"override_with_real_ip"`
	ExtendAliSLSConfig        *CommonLogConfigYAML_BKE_AliSLS_ExtendCfg `yaml:"extend_alisls_config"`
}

type CommonLogConfigYAML_BKE_Console struct {
	To string `yaml:"to"`
}

type CommonLogConfigYAML_BKE_File_RotateConfig struct {
	MaxSize    int  `yaml:"maxsize"`
	MaxAge     int  `yaml:"maxage"`
	MaxBackups int  `yaml:"maxbackups"`
	LocalTime  bool `yaml:"localtime"`
	Compress   bool `yaml:"compress"`
}

type CommonLogConfigYAML_BKE_File struct {
	Filename     string                                     `yaml:"filename"`
	FVConsole    bool                                       `yaml:"fvconsole"`
	Rotate       bool                                       `yaml:"rotate"`
	RotateConfig *CommonLogConfigYAML_BKE_File_RotateConfig `yaml:"rotate_config"`
}

type CommonLogConfigYAML_Backend struct {
	Type          string                           `yaml:"type"`
	Level         string                           `yaml:"level"`
	ConsoleConfig *CommonLogConfigYAML_BKE_Console `yaml:"console_config"`
	FileConfig    *CommonLogConfigYAML_BKE_File    `yaml:"file_config"`
	AliSLSConfig  *CommonLogConfigYAML_BKE_AliSLS  `yaml:"alisls_config"`
}

type CommonLogConfigYAML struct {
	Enable   bool                                   `yaml:"enable"`
	Backends map[string]CommonLogConfigYAML_Backend `yaml:"backends"`
}
