package hiedabke_alisls

import "github.com/aliyun/aliyun-log-go-sdk/producer"

func NewHiedaBackendAliSLS(cfg AliSLSConfig, extraAliSLSConfig *AliSLSConfigExtend) *HiedaBackendAliSLS {
	o := &HiedaBackendAliSLS{
		proj:     cfg.Project,
		logstore: cfg.Logstore,
		topic:    cfg.Topic,
		hostname: cfg.Hostname,
		appname:  cfg.AppName,
		srcip:    cfg.SourceIP,
	}
	alicfg := producer.GetDefaultProducerConfig()
	alicfg.Endpoint = cfg.Endpoint
	alicfg.AccessKeyID = cfg.AccessKeyID
	alicfg.AccessKeySecret = cfg.AccessKeySecret
	if extraAliSLSConfig != nil {
		alicfg.TotalSizeLnBytes = extraAliSLSConfig.TotalSizeLnBytes
		alicfg.MaxIoWorkerCount = extraAliSLSConfig.MaxIoWorkerCount
		alicfg.MaxBlockSec = extraAliSLSConfig.MaxBlockSec
		alicfg.MaxBatchSize = extraAliSLSConfig.MaxBatchSize
		alicfg.MaxBatchCount = extraAliSLSConfig.MaxBatchCount
		alicfg.LingerMs = extraAliSLSConfig.LingerMs
		alicfg.Retries = extraAliSLSConfig.Retries
		alicfg.MaxReservedAttempts = extraAliSLSConfig.MaxReservedAttempts
		alicfg.BaseRetryBackoffMs = extraAliSLSConfig.BaseRetryBackoffMs
		alicfg.MaxRetryBackoffMs = extraAliSLSConfig.MaxRetryBackoffMs
		alicfg.AdjustShargHash = extraAliSLSConfig.AdjustShargHash
		alicfg.Buckets = extraAliSLSConfig.Buckets
		alicfg.AllowLogLevel = extraAliSLSConfig.AllowLogLevel
		alicfg.LogFileName = extraAliSLSConfig.LogFileName
		alicfg.IsJsonType = extraAliSLSConfig.IsJsonType
		alicfg.LogMaxSize = extraAliSLSConfig.LogMaxSize
		alicfg.LogMaxBackups = extraAliSLSConfig.LogMaxBackups
		alicfg.LogCompress = extraAliSLSConfig.LogCompress
		alicfg.NoRetryStatusCodeList = extraAliSLSConfig.NoRetryStatusCodeList
	} else {
		if cfg.DebugMode {
			alicfg.AllowLogLevel = "debug"
		} else {
			alicfg.AllowLogLevel = "error"
		}
	}
	o.prod = producer.InitProducer(alicfg)
	return o
}
